/*
  Arduino Due ADC v1, A7 => 12bits on PORTC pins, ~687kSa/s.
  Processing delay ~1.8..3.3us, jitter ~1.5uspp.
  Stay in 0...3.3V range on pin A7!
  Formula for PicoScope MSO math channel DAC:

  LowPass((2048*D11+1024*D10+512*D9+256*D8+128*D7+64*D6+32*D5+16*D4+8*D3+4*D2+2*D1+1*D0)/4096/0.9998,175000)*3.33

  By HrHunt @ PicoTech forum
  E-mail: info@lab.fyi
  Thread: https://www.picotech.com/support/topic27831.html

  33 C1 D0
  34 C2 D1
  35 C3 D2
  36 C4 D3
  37 C5 D4
  38 C6 D5
  39 C7 D6
  40 C8 D7

  51 C12 D8
  50 C13 D9
  49 C14 D10
  48 C15 D11
*/

void setup()
{
  ADC->ADC_MR |= 0x80;  // ADC to free run
  ADC->ADC_CHER = 0x01; // ADC A7 enable, stay in 0...3.3V range!

  REG_PIOC_OWER = 0xFFFFFFFF;
  REG_PIOC_OER = 0xFFFFFFFF;
}

void loop()
{
  while (true)
  {
    while((ADC->ADC_ISR & 0x01) == 0x00); 
    REG_PIOC_ODSR = ((ADC->ADC_CDR[0] & 0x000000FF) << 1) | ((ADC->ADC_CDR[0] & 0x00000F00) << 4);
  }
}
